function matlab_preprocessing(Input_c,name_Ic_in,name_Ig_in, N, gap_size, min_radius)

Input_c         = double(imread(Input_c))/255;
Input_g         = sum(Input_c,3)/3;

% Ig_in           = SimplestColorBalance(Input_g,.001,.001);
% Ig_in           = Input_g;

% norm_coeff      = Ig_in./Input_g;

% imwrite(uint8(255*Ig_in),name_Ig_in);
imwrite(uint8(255*Input_g),name_Ig_in);

% clear Ig_in Input_g;

% Ic_in           = zeros(size(Input_c));
% Ic_in(:,:,1)    = Input_c(:,:,1).*norm_coeff;
% Ic_in(:,:,2)    = Input_c(:,:,2).*norm_coeff;
% Ic_in(:,:,3)    = Input_c(:,:,3).*norm_coeff;

% imwrite(uint8(255*Ic_in),name_Ic_in);
imwrite(uint8(255*Input_c),name_Ic_in);

% clear Ic_in;

% areas = round(linspace(...
%         sqrt(str2double(min_area)),...
%         sqrt(str2double(max_area)),...
%         str2double(N)).^2);

N           = round(str2double(N));
gap_size    = str2double(gap_size);
min_radius  = str2double(min_radius);
areas       = (min_radius + (0:(N-1)).*gap_size).^2;
    
file  = fopen('mgf_command.txt','w');
fprintf(file,'input_gray.png %s %s\n',num2str(N),num2str(areas));
fclose(file);

fprintf('mgf_command.txt successfully written with command:\n');
fprintf('./multigrainfilter input_gray.png %s %s\n\n',num2str(N),num2str(areas));

end
